%define name 		lapack
%define version 	3.1.1
%define release 	%mkrel 3


Name: 		%{name}
Version: 	%{version}
Release: 	%{release}
Summary: 	LAPACK libraries for linear algebra
License: 	BSD-like
Group:		Sciences/Mathematics
URL: http://www.netlib.org/lapack/
Source0: http://www.netlib.org/lapack/lapack-%{version}.tgz
Source3: Makefile.lapack
Source4: http://www.netlib.org/lapack/lapackqref.ps
Patch3: lapack-3.1.1-make.inc.patch
Obsoletes:	lapack-man  lapack
Obsoletes:	liblapack3.0
Provides:		lib%{name}
BuildRequires:	gcc-gfortran
BuildRequires:	libblas-devel
Requires: 	libblas
Requires:   	glibc >= 2.10.1
Requires:   	libstdc++6 >= 4.4.1
BuildRoot: 	%{_tmppath}/%{name}-%{version}
Obsoletes:	%name < %version

%description
LAPACK (Linear Algebra PACKage) is a standard library for numerical
linear algebra.  LAPACK provides routines for solving systems of
simultaneous linear equations, least-squares solutions of linear
systems of equations, eigenvalue problems, and singular value
problems.  Associated matrix factorizations (LU, Cholesky, QR, SVD,
Schur, and generalized Schur) and related computations (i.e.,
reordering of Schur factorizations and estimating condition numbers)
are also included.  LAPACK can handle dense and banded matrices, but
not general sparse matrices.  Similar functionality is provided for
real and complex matrices in both single and double precision.  LAPACK
is coded in Fortran77.

The lapack package provides the dynamic libraries for LAPACK.


%package -n %{name}-devel
Summary: 	LAPACK static library
Group:		Sciences/Mathematics
Requires: 	%{name} = %{version}
Requires: 	libblas-devel
Obsoletes:	liblapack3.0-devel
Provides:		lib%{name}-devel

%description -n %{name}-devel
LAPACK (Linear Algebra PACKage) is a standard library for numerical
linear algebra.  LAPACK provides routines for solving systems of
simultaneous linear equations, least-squares solutions of linear
systems of equations, eigenvalue problems, and singular value
problems.  Associated matrix factorizations (LU, Cholesky, QR, SVD,
Schur, and generalized Schur) and related computations (i.e.,
reordering of Schur factorizations and estimating condition numbers)
are also included.  LAPACK can handle dense and banded matrices, but
not general sparse matrices.  Similar functionality is provided for
real and complex matrices in both single and double precision.  LAPACK
is coded in Fortran77.

This package contains the headers and development libraries
necessary to develop or compile applications.

%prep
%setup -q
%setup -q -D -T 
%patch3 -p1
cp -f INSTALL/make.inc.gfortran make.inc
cp -f $RPM_SOURCE_DIR/Makefile.lapack SRC/Makefile

#Empty
rm -f man/manl/zbcon.l

%build
RPM_OPT_O_FLAGS=$(echo $RPM_OPT_FLAGS | sed 's|-O2|-O0|')
export FC=gfortran

# Some files don't like -O2, but -Os is fine
RPM_OPT_SIZE_FLAGS=$(echo $RPM_OPT_FLAGS | sed 's|-O2|-Os|')

# Build the static dlamch, dsecnd, lsame, second, slamch bits
pushd INSTALL
make NOOPT="$RPM_OPT_SIZE_FLAGS" OPTS="$RPM_OPT_FLAGS"
popd

# Build the static lapack library
pushd SRC
make FFLAGS="$RPM_OPT_FLAGS" CFLAGS="$RPM_OPT_FLAGS" static
cp liblapack.a ${RPM_BUILD_DIR}/%{name}-%{version}/
popd

# Build the shared dlamch, dsecnd, lsame, second, slamch bits
pushd INSTALL
make clean
make NOOPT="$RPM_OPT_SIZE_FLAGS -fPIC" OPTS="$RPM_OPT_FLAGS -fPIC"
popd

# Build the shared lapack library
pushd SRC
make clean
make FFLAGS="$RPM_OPT_FLAGS -fPIC" CFLAGS="$RPM_OPT_FLAGS -fPIC" shared
cp liblapack.so.3.1.1 ${RPM_BUILD_DIR}/%{name}-%{version}/
popd

# Build the static with pic dlamch, dsecnd, lsame, second, slamch bits
pushd INSTALL
make clean
make NOOPT="$RPM_OPT_SIZE_FLAGS -fPIC" OPTS="$RPM_OPT_FLAGS -fPIC"
popd

# Build the static with pic lapack library
pushd SRC
make clean
make FFLAGS="$RPM_OPT_FLAGS -fPIC" CFLAGS="$RPM_OPT_FLAGS -fPIC" static
cp liblapack.a ${RPM_BUILD_DIR}/%{name}-%{version}/liblapack_pic.a
popd

cp %{SOURCE4} lapackqref.ps

%install
rm -fr ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/manl

for f in liblapack.so.3.1.1 liblapack.a liblapack_pic.a; do
  cp -f $f ${RPM_BUILD_ROOT}%{_libdir}/$f
done

cd ${RPM_BUILD_ROOT}%{_libdir}
ln -sf liblapack.so.3.1.1 liblapack.so
ln -sf liblapack.so.3.1.1 liblapack.so.3
ln -sf liblapack.so.3.1.1 liblapack.so.3.1

%clean
rm -fr %{buildroot}

%post -n %{name}
/sbin/ldconfig

%postun -n %{name}
/sbin/ldconfig


%files -n lapack
%defattr(-,root,root,-)
%{_libdir}/liblapack.so.*

%files -n lapack-devel
%defattr(-,root,root,-)
%{_libdir}/liblapack.so
%{_libdir}/liblapack*.a


%changelog
* Tue Oct 6 2009 Joble <gablej@srt.com> 3.1-3pclos2010
- rebuilt against the new toolchain

* Mon Mar 3 2008 Patred TheKnight <edupclos@gmail.com> 3.1.1-2mypclinuxos-contrib
- Updated version
- rewrote spec file to reflect package changes (included blas, manuals,...)
- Removed Blas from lapack

* Sun Sep 02 2007 Patred TheKnight <edupclos@gmail.com> 3.0-1pclos
- Rebuild for PCLinuxOS


